Index: lucene/core/src/java/org/apache/lucene/document/Document.java
===================================================================
--- lucene/core/src/java/org/apache/lucene/document/Document.java	(revision 1377243)
+++ lucene/core/src/java/org/apache/lucene/document/Document.java	(working copy)
@@ -45,8 +45,6 @@
 public final class Document implements IndexDocument{
 
   private final List<Field> fields = new ArrayList<Field>();
-  
-  //private final List<Field> fields
 
   /** Constructs a new document with no fields. */
   public Document() {}
@@ -291,28 +289,24 @@
   /** Obtains all indexed fields in document */
   @Override
   public Iterable<? extends IndexableField> indexableFields() {
-    Iterator<Field> it = indexedFieldsIterator();
-    
-    List<IndexableField> result = new ArrayList<IndexableField>();
-    while(it.hasNext()) {
-      result.add(it.next());
-    }
-    
-    return result;
+    return new Iterable<Field>() {
+      @Override
+      public Iterator<Field> iterator() {
+        return Document.this.indexedFieldsIterator();
+      }
+    };
   }
 
 
   /** Obtains all stored fields in document. */
   @Override
   public Iterable<? extends StorableField> storableFields() {
-    Iterator<Field> it = storedFieldsIterator();
-    
-    List<StorableField> result = new ArrayList<StorableField>();
-    while(it.hasNext()) {
-      result.add(it.next());
-    }
-    
-    return result;
+    return new Iterable<Field>() {
+      @Override
+      public Iterator<Field> iterator() {
+        return Document.this.storedFieldsIterator();
+      }
+    };
   }
 
   private Iterator<Field> storedFieldsIterator() {
